#include <stdlib.h>
#include <time.h>
#include "buffer.h"
#include "context.h"
#include "scan.h"

static unsigned long len;
static unsigned long maxlen;
static unsigned long maxdepth;

static void
put(void)
{
    char c = 'x';
    len++;
    buffer_PUTC(buffer_1, c);
}

static void
spew(unsigned long depth)
{
    if (len >= maxlen) {
	put();
	return;
    }

    while (len < maxlen) {

	if (depth == maxdepth) {
	    put();
	    return;
	}

	if (depth == 0 || (random() & 1)) {
	    int tag = random() % (Tag_Count - 1);
	    tag++;
	    len += tag_cost[tag];
	    buffer_puts(buffer_1, tag_open[tag]);
	    spew(depth + 1);
	    buffer_puts(buffer_1, tag_close[tag]);
	}

	else {
	    put();
	    return;
	}
    }
}

int
main(int argc, char **argv)
{
    scan_ulong(argv[1], &maxlen);
    scan_ulong(argv[2], &maxdepth);

    srandom(time(0));

    spew(0);

    buffer_flush(buffer_1);

    return 0;
}

